package ru.dbotthepony.mc.otm.capability.matter;

import net.minecraft.MethodsReturnNonnullByDefault;
import ru.dbotthepony.mc.otm.core.Fraction;

import javax.annotation.Nonnull;
import javax.annotation.ParametersAreNonnullByDefault;
import java.math.BigDecimal;

@MethodsReturnNonnullByDefault
@ParametersAreNonnullByDefault
public interface IMatterHandler {
	enum MatterDirection {
		RECEIVE, // consumer
		EXTRACT, // producer
		BIDIRECTIONAL // storage
	}

	Fraction getStoredMatter();
	Fraction getMaxStoredMatter();

	Fraction receiveMatterOuter(Fraction howMuch, boolean simulate);
	Fraction receiveMatterInner(Fraction howMuch, boolean simulate);

	Fraction extractMatterOuter(Fraction howMuch, boolean simulate);
	Fraction extractMatterInner(Fraction howMuch, boolean simulate);

	MatterDirection getDirection();

	default Fraction getMissingMatter() {
		return getMaxStoredMatter().minus(getStoredMatter());
	}
}
