package ru.dbotthepony.mc.otm.menu;

import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.inventory.MenuType;
import net.minecraft.world.level.block.entity.BlockEntity;
import ru.dbotthepony.mc.otm.Registry;
import ru.dbotthepony.mc.otm.block.entity.BlockEntityEnergyCounter;
import ru.dbotthepony.mc.otm.menu.data.BigDecimalDataContainer;
import ru.dbotthepony.mc.otm.menu.data.FractionDataContainer;

import javax.annotation.Nullable;

public class EnergyCounterMenu extends MatteryMenu {
	public final FractionDataContainer passed = new FractionDataContainer();
	public final FractionDataContainer average = new FractionDataContainer();
	public final FractionDataContainer last_20_ticks = new FractionDataContainer();
	// TODO: Graph and proper networking for it
	private int ticks_passed = 0;

	public EnergyCounterMenu(int p_38852_, Inventory inventory) {
		this(p_38852_, inventory, null);
	}

	public EnergyCounterMenu(int p_38852_, Inventory inventory, BlockEntityEnergyCounter tile) {
		super(Registry.Menus.ENERGY_COUNTER, p_38852_, inventory, tile);

		addDataSlots(passed);
		addDataSlots(average);
		addDataSlots(last_20_ticks);
	}

	@Override
	public void broadcastChanges() {
		if (tile != null) {
			BlockEntityEnergyCounter tile = (BlockEntityEnergyCounter) this.tile;

			passed.setValue(tile.getPassed());
			average.setValue(tile.calcAverage(20));

			if (ticks_passed == 0) {
				last_20_ticks.setValue(tile.sumHistory(20));
			}

			ticks_passed = (ticks_passed + 1) % 20;
		}

		super.broadcastChanges();
	}

	@Override
	protected int getWorkingSlotStart() {
		return 0;
	}

	@Override
	protected int getWorkingSlotEnd() {
		return 0;
	}
}
