package ru.dbotthepony.mc.otm.menu.data;

import net.minecraft.client.Minecraft;
import net.minecraft.network.FriendlyByteBuf;
import net.minecraftforge.network.NetworkEvent;

import java.util.function.Supplier;

public record StackRemovePacket(int id, int stack_id) {
	public void write(FriendlyByteBuf buffer) {
		buffer.writeInt(id);
		buffer.writeInt(stack_id);
	}

	public static StackRemovePacket read(FriendlyByteBuf buffer) {
		var id = buffer.readInt();
		var stack_id = buffer.readInt();

		return new StackRemovePacket(id, stack_id);
	}

	public void play(Supplier<NetworkEvent.Context> context) {
		context.get().setPacketHandled(true);
		context.get().enqueueWork(() -> {
			var get = Minecraft.getInstance().player.containerMenu instanceof INetworkedItemViewSupplier supplier && Minecraft.getInstance().player.containerMenu.containerId == id ? supplier.getNetworkedItemView() : null;

			if (get == null) {
				throw new IllegalStateException("No such item tracker with id " + id);
			}

			var get_state = get.state.remove(stack_id);

			if (get_state == null) {
				throw new IllegalStateException("Item tracker " + id + " has no stack with id of " + stack_id);
			}

			get.clearCache();
		});
	}
}
