package ru.dbotthepony.mc.otm.client.screen.panels

import ru.dbotthepony.mc.otm.client.screen.MatteryScreen

open class DraggableCanvasPanel @JvmOverloads constructor(
	screen: MatteryScreen<*>,
	parent: EditablePanel?,
	x: Float = 0f,
	y: Float = 0f,
	width: Float = 10f,
	height: Float = 10f
) : EditablePanel(
	screen, parent, x, y, width, height
) {
	protected var dragging = false
	protected var lastMouseX = 0.0
	protected var lastMouseY = 0.0

	override fun mouseClickedInner(mouse_x: Double, mouse_y: Double, flag: Int): Boolean {
		dragging = true
		lastMouseX = mouse_x
		lastMouseY = mouse_y
		ignoreMouseEventBoundaries = true
		return true
	}

	override fun mouseReleasedInner(mouse_x: Double, mouse_y: Double, flag: Int): Boolean {
		dragging = false
		ignoreMouseEventBoundaries = false
		return true
	}

	override fun mouseDraggedInner(
		mouse_x: Double,
		mouse_y: Double,
		flag: Int,
		drag_x: Double,
		drag_y: Double
	): Boolean {
		if (dragging) {
			xOffset -= (lastMouseX - mouse_x).toFloat()
			yOffset -= (lastMouseY - mouse_y).toFloat()
			lastMouseX = mouse_x
			lastMouseY = mouse_y
		}
		return true
	}

	init {
		scissor = true
	}
}