package ru.dbotthepony.mc.otm.graph.matter

import ru.dbotthepony.mc.otm.capability.matter.*
import ru.dbotthepony.mc.otm.graph.Graph6Node

interface IMatterGraphListener {
	fun onPatternAdded(state: PatternState) {}
	fun onPatternRemoved(state: PatternState) {}
	fun onPatternUpdated(new_state: PatternState, old_state: PatternState) {}

	fun onMatterTaskCreated(task: MatterTask) {}
	fun onMatterTaskUpdated(new_state: MatterTask, old_state: MatterTask) {}
	fun onMatterTaskFinished(state: MatterTask) {}
	fun onMatterTaskRemoved(state: MatterTask) {}
}

interface IMatterGraphNode : IMatterGraphListener {
	fun getMatterHandler(): IMatterHandler? = null
	fun getPatternHandler(): IPatternStorage? = null
	fun getTaskHandler(): IMatterTaskProvider? = null
	fun getAsMatterNode(): Graph6Node<IMatterGraphNode>
	fun getAsMatterGraph(): MatterNetworkGraph? = getAsMatterNode().graph as MatterNetworkGraph?
}
